#= Metasequoiaf[^̃[_
# 'mqo/loader.rb'

require 'mqo/dom'
require 'mqo/parser'

module Metasequoia
   class Face
      def initialize(vnum, vertex_id, material = nil, uv = nil, vcol = nil)
         @vnum, @vertex_id, @uv, @vcol = vnum, vertex_id, uv, vcol
         @material = (material || :default)
      end
   end
   class Object
      def initialize(name)
         @name = name
      end
   end
   class Material
      def initialize(name, rgba, mat_hash)
         @name = name
         @color = Color.new(* rgba)
         mat_hash.each{|key,val|
            case key
            when 'tex'
               @tex = val[1..-2]
            when 'aplane'
               @aplane = val[1..-2]
            when 'bump'
               @bump = val[1..-2]
            else
               eval "@#{key} = #{val}"
            end
         }
      end
   end
   class BackImage
      def initialize(view, file, opt)
         @view, @file, @opt = view, file, opt
      end
   end

   class Loader < Parser
      # DOMo͂ꍇ̓[gIuWFNgo͂
      def document_start(ver)
         raise FormatError if ver != 1
         mqo = Document.new
         mqo.objects = ObjectChunk.new
         return mqo
      end
      def document_end
      end
      # m̃`N̏
      def chunk_start(chunk, opt)
         return nil
      end
      # DOMo͂ꍇ̓V[IuWFNgo͂
      def scene_chunk_start
         print "#{@current.class} -> scene\n" if $Debug
         return @current.scene = Scene.new
      end
      # DOMo͂ꍇ͉GIuWFNgo͂
      def backimage_chunk_start
         print "#{@current.class} -> backimage\n" if $Debug
         return @current.backimages = BackImageChunk.new
      end
      # DOMo͂ꍇ͍ގXgIuWFNgo͂
      def material_chunk_start(mat_num)
         print "#{@current.class} -> material\n" if $Debug
         return @current.materials = MaterialChunk.new
      end
      # DOMo͂ꍇ̓fIuWFNgo͂
      def object_chunk_start(obj_name)
         print "#{@current.class} -> object\n" if $Debug
         ret = Object.new(obj_name)
         @current.objects << ret
         return ret
      end
      # DOMo͂ꍇ͔SyIuWFNgo͂
      def blob_chunk_start(opt)
         return nil
      end
      # DOMo͂ꍇ͒_XgIuWFNgo͂
      def vertex_chunk_start(vnum)
         print "#{@current.class} -> vertex\n" if $Debug
         return @current.vertices = VertexChunk.new
      end
      # DOMo͂ꍇ͒_XgIuWFNgo͂
      def vertexattr_chunk_start()
         print "#{@current.class} -> vertexattr\n" if $Debug
         return @current.vertexattr = VertexAttr.new
      end
      # DOMo͂ꍇ͒_d݃XgIuWFNgo͂
      def weit_chunk_start()
         print "#{@current.class} -> weit\n" if $Debug
         return @current.weit = Weit.new
      end
      # DOMo͂ꍇ͖ʃXgIuWFNgo͂
      def face_chunk_start(fnum)
         print "#{@current.class} -> face\n" if $Debug
         return @current.faces = FaceChunk.new
      end
      # `N̏ICxg
      def chunk_end
         print "#{@parent.last.class} <- #{@current.class}\n" if $Debug
      end
      # _f[^
      def vertex_value(x, y, z)
         @current << Vertex.new(x, y, z)
      end
      # _̏d
      def weit_value(vid, weit)
         @current << [vid, weit]
      end
      # ʃf[^
      def face_value(vnum, vtx, mat_id, uv_ary, vcol)
         uv_ary.map!{|x| UV.new(x[0], x[1])}
         @current << Face.new(vnum, vtx, mat_id, uv_ary, vcol)
      end
      # ގf[^
      def material_value(mat_name, rgba, mat_hash)
         @current << Material.new(mat_name, rgba, mat_hash)
      end
      # Gf[^
      def backimage_value(view, file, opt)
         @current << BackImage.new(view, file, opt)
      end
      # xNg^̑f[^
      def attr_vector_value(atr, x, y, z)
         begin
            eval "@current.#{atr} = Vector.new(x, y, z)"
         rescue
         end
      end
      # Float^̑f[^
      def attr_float_value(atr, val)
         begin
            eval "@current.#{atr} = val"
         rescue
         end
      end
      # Int^̑f[^
      def attr_int_value(atr, val)
         begin
            eval "@current.#{atr} = val"
         rescue
         end
      end

      def load
         parse
         return @root
      end
   end

   def self.load(filename)
      raise FormatError unless filename =~ /\.mqo$/i
      mqoLD = Loader.new(filename)
      return mqoLD.load
   end
end

#= PƂŌĂяoꂽꍇ̂ݗLȏB
# CuƂČĂяoꂽꍇɂ͖B
if $0 == __FILE__
   #$Debug = true

   print "MQO file loading ..."
   ptime = Process.times.utime
   mqo = Metasequoia::load('test.mqo')
   print "complete! (Elapsed time: #{Process.times.utime - ptime}s)\n"
   open('test-out.mqo','w'){|io|
      mqo.fputs(io)
   }
end
